program ListyPosortowane;

{Implementacja operacji na posortowanych listach prostych.}
{Materiay do wykadu z Technik Programowania na ZSI}
{Autor: Janusz Jabonowski}
{2004}

type
  TypDanych = String; {W listach bdziemy przechowywa napisy}

  TLista     = ^TEltListy;
  TEltListy = record
                     dane: TypDanych;
                      nast: TLista;
                    end;

{
Uwaga:
  Operacje:
   procedure Ini(var l: TLista);
   procedure PrzejdzListe(l: TLista);
   function DlugoscListy(l: TLista): Integer;
   procedure UsunWszystkoZListy(var l: TLista);
   procedure UsunPierwszy(var l: TLista);
  dla listy posortowanej s identyczne z operacjami dla listy zwykej, wic
zostay tu pominite.
  Natomiast operacje:
   procedure WstawNaPocz(var l: TLista; dane: TypDanych);
   procedure WczytajListeOdwrotnie(var l:Tlista);
   procedure WstawNaKoniec(var l: TLista; dane: TypDanych);
   procedure WczytajListePoKolei(var l:Tlista);
  dla listy posortowanej nie maj sensu
}

procedure Wstaw(var l: TLista; dane: TypDanych);
 {Dostawia element do listy posortowanej}
 var
  pom   : TLista;
  poprz : TLista;
  biez  : TLista;
 begin
  {Szukam miejsca do wstawienia}
  poprz := nil;
  biez := l;
  {$B-}
  while (biez <> nil) and (biez^.dane < dane) do
   begin
    poprz := biez;
    biez := biez^.nast;
   end;
  {Tworz nowe pudeko}
  new(pom);
  pom^.dane := dane;
  pom^.nast := biez;
  {Wstawiam midzy poprz a bie}
  if poprz <> nil
  then
    poprz^.nast := pom
  else {poprz = nil}
    l := pom
 end; {Wstaw}

procedure WczytajListeS(var l:Tlista);
 {Wczytuje list element po elemencie od uytkownika.}
var
  napis: string;
 begin
  {Na pocztku lista jest pusta}
  Ini(l);
  napis := '';
  {Teraz po kolei dopisuj do niej nowe elementy}
  repeat
    write('Podaj kolejny napis (pusty koczy): ');
    readln(napis);
    if napis <> ''
    then
      Wstaw(l, napis)
  until napis = '';
 end; {WczytajListS}

function SzukajS(l: TLista; Co: TypDanych): Integer;
 {Szuka liczby Co na licie l. Jeli Co wystpuje na licie daje}
 {jako wynik pozycj pierwszego wystapienia Co na licie, wpp. daje 0.}
 var
  wyn: Integer;
 begin
  Wyn := 1;
  {Szukam miejsca, w ktrym powinien by element Co}
  {$B-}
  while (l <> nil) and (l^.dane < Co) do
   begin
    wyn := wyn + 1;
    l := l^.nast;
   end;
  {$B-}
  if (l <> nil) and (l^.dane = Co)
  then {Jest}
   SzukajS := Wyn
  else {Nie ma}
   SzukajS := 0;
 end; {SzukajS}

 procedure UsunWskazanyS(var l: TLista; Wskazany: TypDanych);
  {Usuwa wszystkie wystpienia elementu Wskazany z listy l.}
  var
   Poprz, Biez: TLista;  {Poprzedni i biecy element na licie}
   pom: TLista; {Pomocnicza, do usuwania elementu z listy}
  begin
   {Szukam miejsca z elementami Wskazany}
   poprz := nil;
   biez := l;
   {$B-}
   while (biez <> nil) and (biez^.dane < Wskazany) do
    begin
     poprz := biez;
     biez := biez^.nast;
    end;
   {Jeli elementy o wartoci Wskazany s na licie, to musz by wanie tu}
   {$B-}
   while (biez <> nil) and (biez^.dane = wskazany) do
    begin	
     {Usuwam element Biez}
     pom := biez;
     if poprz <> nil
     then {Usuwam kolejny (tj. nie pierwszy) element listy}
       poprz^.nast := Biez^.nast
     else {Usuwam pierwszy element listy}
       l := Biez^.nast;
     biez := biez^.nast;
     dispose(pom);
   end;
  end; {UsuWskazanyS}

begin {program gwny}
 {...}
end.
